package com.cultural.heritage.model.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

@TableName(value = "good")
@Data

public class Good {
    /**
     * 商品编号
     */
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 商品名
     */
    private String name;

    /**
     * 商品类型
     */
    private String type;

    /**
     * 商品价格
     */
    private Double price;

    /**
     * 商品图片
     */
    private String goodImg;

    /**
     * 商品简介
     */
    private String intro;

    /**
     * 商品详情简介
     */
    private String introDetail;

    /**
     * 商品详情图片
     */
    private String detailImg;

    /**
     * 商品标签
     */
    private String label;

    /**
     * 商品库存量
     */
    private Integer inventory;

    /**
     * 是否是商品类型
     */
    private Integer isGoodType;

    /**
     * 节日限定序号
     */
    private Integer festivalOrder;

    /**
     * 预约日期
     */
    private String reserveDate;

    /**
     * 是否上架
     */
    private Integer isShelves;


    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

}
